blob: 52393d4dad80dab28d57bad7288ac50af251f387 [file] [log] [blame]
Petr Michalec1ed1b3c2017-08-08 19:19:01 +02001#!/bin/bash -e
2
3# bootstrap.sh
4
5# Installs Salt and configure minimal SaltMaster or Minion to be used with:
6# - http://github.com/salt-formulas-scripts
7# - http://github.com/salt-formulas/salt-formula-salt (salt.master sls)
8
9# TODO:
10# - use PPA repository as formula source
11# - support for spm/yum
12
13
14# Source specific env vars.
15# shopt -u dotglob
16export RECLASS_ROOT=${RECLASS_ROOT:-/srv/salt/reclass}
17function source_local_envs() {
Petr Michalecb444ef92017-08-17 13:53:14 +020018 for path in / /tmp/kitchen /srv/salt . ${RECLASS_ROOT}/classes/cluster ${RECLASS_ROOT}/classes/cluster/${CLUSTER_NAME}; do
Vasyl Saienko7a4161c2017-08-14 17:43:15 +030019 for f in $(find $path -maxdepth 1 -name '*.env' 2> /dev/null); do
20 echo "Sourcing env variables from $f"
21 source $f
22 done
23 done
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020024}
25source_local_envs
26
27##########################################
28# Set defaults env variables
29
30if [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
31 set -x
32 SALT_LOG_LEVEL="--state-verbose=true -ldebug"
33fi
34
35export MAGENTA='\033[0;95m'
36export YELLOW='\033[1;33m'
37export BLUE='\033[0;35m'
38export CYAN='\033[0;96m'
39export RED='\033[0;31m'
40export NC='\033[0m' # No Color'
41
42export LC_ALL=C
43export SALT_LOG_LEVEL="--state-verbose=false -lerror"
44export SALT_OPTS="${SALT_OPTS:- --timeout=120 --state-output=changes --retcode-passthrough --force-color $SALT_LOG_LEVEL }"
45export SALT_STATE_RETRY=${SALT_STATE_RETRY:-3}
46export BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True}
47export BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX stable 2016.3 }
48
49
50# salt apt repository
51test -e /etc/lsb-release && eval $(cat /etc/lsb-release)
52which lsb_release && DISTRIB_CODENAME=${DISTRIB_CODENAME:-$(lsb_release -cs)}
53#
54export APT_REPOSITORY="deb [arch=amd64] http://apt-mk.mirantis.com/${DISTRIB_CODENAME} ${DISTRIB_REVISION:-stable} salt"
55export APT_REPOSITORY_GPG=${APT_REPOSITORY_GPG:-http://apt-mk.mirantis.com/public.gpg}
56
57# reclass
58export RECLASS_ADDRESS=${RECLASS_ADDRESS:-https://github.com/salt-formulas/openstack-salt.git} # https/git
59
60# formula
61export FORMULAS_BASE=${FORMULAS_BASE:-https://github.com/salt-formulas}
62export FORMULAS_PATH=${FORMULAS_PATH:-/usr/share/salt-formulas}
63export FORMULAS_BRANCH=${FORMULAS_BRANCH:-master}
64export FORMULAS_SOURCE=${FORMULAS_SOURCE:-pkg} # pkg/git
65# essential set of formulas (known to by used on cfg01 node for most setups)
chnyda86d63b42017-08-31 10:05:00 +020066FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS memcached openssh ntp nginx collectd sensu heka sphinx mysql grafana libvirt rsyslog glusterfs postfix xtrabackup freeipa prometheus telegraf elasticsearch kibana rundeck devops-portal rsync docker keepalived aptly jenkins gerrit artifactory influxdb}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020067# minimal set of formulas for salt-master bootstrap
68declare -a FORMULAS_SALT_MASTER=(linux reclass salt git $(echo $FORMULAS_SALT_MASTER))
69export FORMULAS_SALT_MASTER
70
71# system / host
Petr Michalecc749e862017-09-06 21:10:10 +020072export HOSTNAME=${HOSTNAME:-`hostname -s`}
73export HOSTNAME=${HOSTNAME//.*/}
74export DOMAIN=${DOMAIN:-`hostname -d`}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020075export DOMAIN=${DOMAIN:-bootstrap.local}
76
77# salt
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020078export MINION_ID=${MINION_ID:-${HOSTNAME}.${DOMAIN}}
Petr Michalec2e3a4992017-08-17 14:20:43 +020079export MASTER_HOSTNAME=${MASTER_HOSTNAME:-${HOSTNAME}.${DOMAIN}}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020080
81# saltstack
82BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True}
83BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX stable 2016.3 }
84SALT_SOURCE=${SALT_SOURCE:-pkg}
85SALT_VERSION=${SALT_VERSION:-latest}
86
87# environment
88if [ "$FORMULAS_SOURCE" == "git" ]; then
89 SALT_ENV=${SALT_ENV:-dev}
90elif [ "$FORMULAS_SOURCE" == "pkg" ]; then
91 SALT_ENV=${SALT_ENV:-prd}
92fi
93eval $(cat /etc/*release 2> /dev/null)
94PLATFORM_FAMILY=$(echo ${ID_LIKE// */} | tr A-Z a-z)
95case $PLATFORM_FAMILY in
96 debian )
97 PKGTOOL="$SUDO apt-get"
98 test ${VERSION_ID//\.*/} -ge 16 && {
99 SVCTOOL=service
100 } || { SVCTOOL=service
101 }
102 ;;
103 rhel )
104 PKGTOOL="$SUDO yum"
105 test ${VERSION_ID//\.*/} -ge 7 && {
106 SVCTOOL=systemctl
107 } || { SVCTOOL=service
108 }
109 ;;
110esac
111
112export PLATFORM_FAMILY
113export PKGTOOL
114export SVCTOOL
115
116##########################################
117# FUNCTIONS
118
119log_info() {
120 echo -e "${YELLOW}[INFO] $* ${NC}"
121}
122
123log_warn() {
124 echo -e "${MAGENTA}[WARN] $* ${NC}"
125}
126
Petr Michalec24b30e82017-08-21 10:59:18 +0200127log_debug() {
128 echo -e "${CYAN}[WARN] $* ${NC}"
129}
130
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200131log_err() {
132 echo -e "${RED}[ERROR] $* ${NC}" >&2
133}
134
135configure_pkg_repo()
136{
137
138 case $PLATFORM_FAMILY in
139 debian)
140 if [ -n "$APT_REPOSITORY_PPA" ]; then
141 which add-apt-repository || $SUDO apt-get install -y software-properties-common
142 $SUDO add-apt-repository -y ppa:${APT_REPOSITORY_PPA}
143 else
144 echo -e "$APT_REPOSITORY " | $SUDO tee /etc/apt/sources.list.d/bootstrap.list >/dev/null
145 curl -sL $APT_REPOSITORY_GPG | $SUDO apt-key add -
146 fi
147 $SUDO apt-get clean
148 $SUDO apt-get update
149 ;;
150 rhel)
151 $SUDO yum install -y https://repo.saltstack.com/yum/redhat/salt-repo-latest-1.el${VERSION_ID}.noarch.rpm
152 $SUDO yum clean all
153 ;;
154 esac
155
156}
157
158_atexit() {
159 RETVAL=$?
160 trap true INT TERM EXIT
161
162 if [ $RETVAL -ne 0 ]; then
163 log_err "Execution failed"
164 else
165 log_info "Execution successful"
166 fi
167 return $RETVAL
168}
169
170retry() {
171 local tries
172 if [[ $1 =~ ^[0-9]+$ ]]; then
173 tries=$1; shift
174 else
175 tries=3
176 fi
177 for i in $(seq 1 $tries); do
178 "$@" && return 0 || sleep $i
179 done
180 return 1
181}
182
183function clone_reclass() {
184 if [ ! -d ${RECLASS_ROOT} ]; then
185 # No reclass at all, clone from given address
186 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
187 if echo ${RECLASS_BRANCH:-master} | egrep -q "^refs"; then
188 git clone ${RECLASS_ADDRESS} ${RECLASS_ROOT}
189 cd ${RECLASS_ROOT}
190 git fetch ${RECLASS_ADDRESS} ${RECLASS_BRANCH:-master} && git checkout FETCH_HEAD
191 cd -
192 else
193 git clone -b ${RECLASS_BRANCH:-master} ${RECLASS_ADDRESS} ${RECLASS_ROOT};
194 fi;
195 fi;
196}
197
198
199##########################################
200# Main calls
201
Petr Michalecda014202017-08-18 11:26:07 +0200202system_config_ssh_conf() {
203 for conf in ~/.ssh/config /root/.ssh/config; do
204 $SUDO mkdir -p $(dirname $conf)
205 if ! grep StrictHostKeyChecking $conf; then
206 # this should be used only in CI environment
207 echo -e "Host *\n\tStrictHostKeyChecking no\n" | $SUDO tee $conf >/dev/null
208 fi
209 done
210 if ! grep github.com ~/.ssh/known_hosts; then
211 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
212 fi
213}
214
215system_config_salt_modules_prereq() {
216 # salt-formulas custom modules dependencies, etc:
217 $SUDO $PKGTOOL install -y iproute2 curl sudo apt-transport-https python-psutil python-apt python-m2crypto python-oauth python-pip &>/dev/null
218}
219
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200220system_config_minion() {
221 log_info "System configuration salt minion"
222}
223
224system_config_master() {
225 log_info "System configuration salt master"
226
Petr Michalecda014202017-08-18 11:26:07 +0200227 system_config_salt_modules_prereq
228 system_config_ssh_conf
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200229
230 $SUDO mkdir -p $RECLASS_ROOT/classes/service
Petr Michalecda014202017-08-18 11:26:07 +0200231 $SUDO mkdir -p $RECLASS_ROOT/nodes/_generated
232
233 if ! grep '127.0.1.2.*salt' /etc/hosts; then
234 echo "127.0.1.2 salt" | $SUDO tee -a /etc/hosts >/dev/null
235 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200236
237 which reclass || $SUDO $PKGTOOL install -y reclass
238
239 which reclass-salt || {
240 test -e /usr/share/reclass/reclass-salt && {
241 ln -fs /usr/share/reclass/reclass-salt /usr/bin
242 }
243 }
244}
245
246configure_salt_master()
247{
248
249 echo "Configuring salt-master ..."
250
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200251 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
252 IGNORE_CLASS_NOTFOUND="ignore_class_notfound: True"
253 fi
254
Petr Michalecdd1a0472017-09-06 19:27:24 +0200255 # to force alternative reclass module path
Petr Michalecd9d0a322017-09-06 19:38:32 +0200256 if [ -n "$RECLASS_SOURCE_PATH" ]; then
257 RECLASS_SOURCE_PATH="reclass_source_path: ${RECLASS_SOURCE_PATH}"
258 else
259 RECLASS_SOURCE_PATH=""
260 fi
Petr Michalecdd1a0472017-09-06 19:27:24 +0200261
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200262 [ ! -d /etc/salt/master.d ] && mkdir -p /etc/salt/master.d
263 cat <<-EOF > /etc/salt/master.d/master.conf
264 file_roots:
265 base:
266 - /usr/share/salt-formulas/env
267 prd:
268 - /srv/salt/env/prd
269 dev:
270 - /srv/salt/env/dev
271 pillar_opts: False
272 open_mode: True
273 reclass: &reclass
274 storage_type: yaml_fs
275 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200276 ${IGNORE_CLASS_NOTFOUND}
Petr Michalecdd1a0472017-09-06 19:27:24 +0200277 ${RECLASS_SOURCE_PATH}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200278 ext_pillar:
279 - reclass: *reclass
280 master_tops:
281 reclass: *reclass
282EOF
283
284 echo "Configuring reclass ..."
285
286 [ ! -d /etc/reclass ] && mkdir /etc/reclass
287 cat <<-EOF > /etc/reclass/reclass-config.yml
288 storage_type: yaml_fs
289 pretty_print: True
290 output: yaml
291 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200292 ${IGNORE_CLASS_NOTFOUND}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200293EOF
294
295 clone_reclass
296 # override some envs from cluster level *.env, use with care
297 source_local_envs
298
299 cd ${RECLASS_ROOT}
300 if [ ! -d ${RECLASS_ROOT}/classes/system/linux ]; then
301 # Possibly subrepo checkout needed
302 git submodule update --init --recursive
303 fi
304
Petr Michalec212cc6a2017-08-17 21:39:40 +0200305 mkdir -vp ${RECLASS_ROOT}/nodes/_generated
Petr Michalec51ece842017-09-06 20:44:15 +0200306 rm -rvf ${RECLASS_ROOT}/nodes/_generated/*
307
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200308 CONFIG=$(find ${RECLASS_ROOT}/nodes -name ${MINION_ID}.yml| grep yml | tail -n1)
Petr Michalec212cc6a2017-08-17 21:39:40 +0200309 CONFIG=${CONFIG:-${RECLASS_ROOT}/nodes/_generated/${MINION_ID}.yml}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200310 if [[ $SALT_MASTER_BOOTSTRAP_MINIMIZED =~ ^(True|true|1|yes)$ || ! -f "${CONFIG}" ]]; then
Petr Michalec24b30e82017-08-21 10:59:18 +0200311 log_warn "Salt Master node specification has not been found in model."
312 log_warn "Creating temporary cfg01 configuration for bootstrap: ${CONFIG}"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200313 cat <<-EOF > ${CONFIG}
314 classes:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200315 - cluster.${CLUSTER_NAME}.infra.config
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200316 parameters:
317 _param:
Petr Michaleca7de6df2017-08-31 12:16:57 +0200318 single_address: ${MASTER_IP:-$MASTER_HOSTNAME}
319 salt_master_host: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200320 salt_master_base_environment: $SALT_ENV
Petr Michalecd81d1f52017-08-17 20:18:06 +0200321 salt_formula_branch: ${SALT_FORMULAS_BRANCH:-master}
322 reclass_data_revision: ${RECLASS_BRANCH:-master}
323 reclass_data_repository: "$RECLASS_ADDRESS"
Petr Michaleca7de6df2017-08-31 12:16:57 +0200324 reclass_config_master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalecd81d1f52017-08-17 20:18:06 +0200325 linux_system_codename: ${DISTRIB_CODENAME}
326 cluster_name: ${CLUSTER_NAME}
327 cluster_domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200328 linux:
329 system:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200330 name: ${HOSTNAME:-cfg01}
331 domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200332 # ########
333EOF
334
335 if [ "$SALT_VERSION" == "latest" ]; then
336 VERSION=""
337 else
338 VERSION="version: $SALT_VERSION"
339 fi
340
341 cat <<-EOF >> ${CONFIG}
342 salt:
343 master:
344 accept_policy: open_mode
345 source:
346 engine: $SALT_SOURCE
347 $VERSION
348 minion:
349 source:
350 engine: $SALT_SOURCE
351 $VERSION
352 # ########
353 # vim: ft=yaml sw=2 ts=2 sts=2
354EOF
355 fi
Petr Michalec24b30e82017-08-21 10:59:18 +0200356
357 log_debug "Salt Master node config yaml:"
358 log_debug "$(cat ${CONFIG})"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200359}
360
361configure_salt_minion()
362{
363 [ ! -d /etc/salt/minion.d ] && mkdir -p /etc/salt/minion.d
364 cat <<-EOF > /etc/salt/minion.d/minion.conf
Petr Michaleca7de6df2017-08-31 12:16:57 +0200365 master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200366 id: $MINION_ID
367 EOF
368}
369
370
371install_salt_master_pkg()
372{
373 echo -e "\nPreparing base OS repository ...\n"
374
375 configure_pkg_repo
376
377 echo -e "\nInstalling salt master ...\n"
378
379 case $PLATFORM_FAMILY in
380 debian)
381 $SUDO apt-get install -y git
382 which reclass || $SUDO apt install -qqq -y reclass
383 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
384 ;;
385 rhel)
386 yum install -y git
387 which reclass || $SUDO yum install -y reclass
388 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
389 ;;
390 esac
391
392 which reclass-salt || {
393 test -e /usr/share/reclass/reclass-salt && {
394 ln -fs /usr/share/reclass/reclass-salt /usr/bin
395 }
396 }
397
398 configure_salt_master
399
400 echo -e "\nRestarting services ...\n"
401 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
402 $SVCTOOL salt-master restart
403}
404
405install_salt_master_pip()
406{
407 echo -e "\nPreparing base OS repository ...\n"
408
409 case $PLATFORM_FAMILY in
410 debian)
411 $SUDO apt-get install -y python-pip python-dev zlib1g-dev git
412 which reclass || $SUDO apt-get install -y reclass
413 ;;
414 rhel)
415 $SUDO yum install -y git
416 which reclass || $SUDO yum install -y reclass
417 ;;
418 esac
419
420 echo -e "\nInstalling salt master ...\n"
421 # TODO: replace with saltstack bootstrap script
422
423 if [ "$SALT_VERSION" == "latest" ]; then
424 pip install salt
425 else
426 pip install salt==$SALT_VERSION
427 fi
428
429 curl -Lo /etc/init.d/salt-master https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-master.init && chmod 755 /etc/init.d/salt-master
430 ln -s /usr/local/bin/salt-master /usr/bin/salt-master
431
432 which reclass-salt || {
433 test -e /usr/share/reclass/reclass-salt && {
434 ln -fs /usr/share/reclass/reclass-salt /usr/bin
435 }
436 }
437
438 configure_salt_master
439
440 echo -e "\nRestarting services ...\n"
441 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
442 $SVCTOOL salt-master restart
443}
444
445
446
447install_salt_minion_pkg()
448{
449
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200450 echo -e "\nInstalling salt minion ...\n"
451
452 case $PLATFORM_FAMILY in
453 debian)
454 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
455 ;;
456 rhel)
457 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
458 ;;
459 esac
460
461
462 configure_salt_minion
463
464 $SVCTOOL salt-minion restart
465}
466
467install_salt_minion_pip()
468{
469 echo -e "\nInstalling salt minion ...\n"
470
471 curl -Lo /etc/init.d/salt-minion https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-minion.init && chmod 755 /etc/init.d/salt-minion
472 ln -s /usr/local/bin/salt-minion /usr/bin/salt-minion
473
474 configure_salt_minion
475 $SVCTOOL salt-minion restart
476}
477
478
479install_salt_formula_pkg()
480{
481 configure_pkg_repo
482
483 case $PLATFORM_FAMILY in
484 debian)
485 echo "Configuring necessary formulas ..."
486
487 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
488 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
489 [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
490 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
491 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
492 [ ! -d "${FORMULAS_PATH}/env/${formula_service}" ] && \
493 if ! $SUDO apt-get install -y salt-formula-${formula_service}; then
494 echo -e "\nInstall salt-formula-${formula_service} failed.\n"
495 exit 1
496 fi
497 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
498 ln -sf ${FORMULAS_PATH}/reclass/service/${formula_service} ${RECLASS_ROOT}/classes/service/${formula_service}
499 done
500 ;;
501 rhel)
502 # TODO
503 ;;
504 esac
505
506 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
507 [ ! -L /srv/salt/env/prd ] && ln -s ${FORMULAS_PATH}/env /srv/salt/env/prd || echo ""
508}
509
510install_salt_formula_git()
511{
512 echo "Configuring necessary formulas ..."
513
514 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
515 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
516 [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
517 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
518 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
519 _BRANCH=${FORMULAS_BRANCH}
520 [ ! -d "${FORMULAS_PATH}/env/_formulas/${formula_service}" ] && {
521 if ! git ls-remote --exit-code --heads ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${_BRANCH}; then
522 # Fallback to the master branch if the branch doesn't exist for this repository
523 _BRANCH=master
524 fi
525 if ! git clone ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${FORMULAS_PATH}/env/_formulas/${formula_service} -b ${_BRANCH}; then
526 echo -e "\nCloning of ${FORMULAS_BASE}/salt-formula-${formula_service}.git failed.\n"
527 exit 1
528 fi
529 } || {
530 cd ${FORMULAS_PATH}/env/_formulas/${formula_service};
531 git fetch origin/${_BRANCH} || git fetch --all
532 git checkout ${_BRANCH} && git pull || git pull;
533 cd -
534 }
535 [ ! -L "/usr/share/salt-formulas/env/${formula_service}" ] && \
536 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/${formula_service} /usr/share/salt-formulas/env/${formula_service}
537 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
538 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/metadata/service ${RECLASS_ROOT}/classes/service/${formula_service}
539 done
540
541 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
542 [ ! -L /srv/salt/env/dev ] && ln -s /usr/share/salt-formulas/env /srv/salt/env/dev || echo ""
543}
544
545
546saltmaster_bootstrap() {
547
548 log_info "Salt master setup"
549 test -n "$MASTER_HOSTNAME" || exit 1
550
551 clone_reclass
552 # override some envs from cluster level *.env, use with care
553 source_local_envs
554
555 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {}
556 pkill -9 salt-minion
557 test -e ${SCRIPTS}/.salt-master-setup.sh.passed || {
Petr Michaleca7de6df2017-08-31 12:16:57 +0200558 export MASTER_IP=localhost
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200559 export MINION_ID=${MASTER_HOSTNAME}
560 if ! [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
561 SALT_MASTER_SETUP_OUTPUT='/dev/stdout'
562 fi
563 # call local "setup() master"
564 #if ! $SUDO ${SCRIPTS}/salt-master-setup.sh master &> ${SALT_MASTER_SETUP_OUTPUT:-/tmp/salt-master-setup.log}; then
565 if ! setup master; then
566 #cat /tmp/salt-master-setup.log
567 log_err "salt master setup() failed."
568 exit 1
569 else
570 $SUDO touch ${SCRIPTS}/.salt-master-setup.sh.passed
571 fi
572 }
573
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200574 log_info "Re/starting salt services"
575 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {}
576 pkill -9 salt-minion
577 sleep 1
578 $SUDO service salt-master restart
579 $SUDO service salt-minion restart
580 sleep 10
581}
582
583# Init salt master
584saltmaster_init() {
585
586 log_info "Runing saltmaster states"
587 test -n "$MASTER_HOSTNAME" || exit 1
588
589 set -e
590 $SUDO salt-call saltutil.sync_all >/dev/null
591
592 # TODO: Placeholder update saltmaster spec (nodes/FQDN.yml) to be able to bootstrap with minimal configuration
593 # (ie: with linux, git, salt formulas)
594
595 #log_info "Verify SaltMaster, before salt-master is fully initialized"
596 #if ! $SUDO reclass-salt -p ${MASTER_HOSTNAME} &> /tmp/${MASTER_HOSTNAME}.pillar;then
597 # log_warn "Node verification before initialization failed."; cat /tmp/${MASTER_HOSTNAME}.pillar;
598 #fi
599
Petr Michalecda014202017-08-18 11:26:07 +0200600
601 # workarond isolated and not fully bootstraped environments
Petr Michalec571d6b82017-08-18 13:25:24 +0200602 PILLAR='{"salt":{"master":{"pillar":{"reclass":{"ignore_class_notfound": "'${RECLASS_IGNORE_CLASS_NOTFOUND:-False}'"}}}}, "reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalecda014202017-08-18 11:26:07 +0200603
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200604 log_info "State: salt.master.env"
Petr Michalecda014202017-08-18 11:26:07 +0200605 if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200606 log_err "State salt.master.env failed, keep your eyes wide open."
607 fi
608
609 log_info "State: salt.master.pillar"
Petr Michalecda014202017-08-18 11:26:07 +0200610 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200611 # Note: sikp reclass data dir states
612 # in order to avoid pull from configured repo/branch
613
614 # Revert temporary SaltMaster minimal configuration, if any
615 pushd $RECLASS_ROOT
616 if [ $(git diff --name-only nodes | sort | uniq | wc -l) -ge 1 ]; then
617 git status || true
Petr Michalecda014202017-08-18 11:26:07 +0200618 log_warn "Locally modified $RECLASS_ROOT/nodes found. (Possibly salt-master minimized setup from bootstrap.sh call)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200619 log_info "Checkout HEAD state of $RECLASS_ROOT/nodes/*."
620 git checkout -- $RECLASS_ROOT/nodes || true
621 log_info "Re-Run states: salt.master.env and salt.master.pillar according the HEAD state."
622 log_info "State: salt.master.env"
Petr Michalecda014202017-08-18 11:26:07 +0200623 if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200624 log_err "State salt.master.env failed, keep your eyes wide open."
625 fi
626 log_info "State: salt.master.pillar"
Petr Michalecda014202017-08-18 11:26:07 +0200627 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200628 fi
629 popd
630
Petr Michalecda014202017-08-18 11:26:07 +0200631 # finally re-configure salt master conf, ie: may remove ignore_class_notfound option
632 log_info "State: salt.master.service"
Petr Michalec7f3e7e72017-08-18 13:49:24 +0200633 $SUDO salt-call ${SALT_OPTS} state.apply salt.master.service || true
Petr Michalecda014202017-08-18 11:26:07 +0200634
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200635 log_info "State: salt.master.storage.node"
636 set +e
Petr Michaleca5141342017-08-16 12:55:20 +0200637 # TODO: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT.
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200638 $SUDO salt-call ${SALT_OPTS} state.apply reclass.storage.node
639 ret=$?
640 set -e
641
642 if [[ $ret -eq 2 ]]; then
643 log_err "State reclass.storage.node failed with exit code 2 but continuing."
644 elif [[ $ret -ne 0 ]]; then
645 log_err "State reclass.storage.node failed with exit code $ret"
646 exit 1
647 fi
648
649 log_info "Re/starting salt services"
650 $SUDO sed -i 's/^master:.*/master: localhost/' /etc/salt/minion.d/minion.conf
651 $SUDO service salt-minion restart >/dev/null
652 $SUDO salt-call ${SALT_OPTS} saltutil.sync_all >/dev/null
653
654 verify_salt_master
655 set +e
656
657}
658
659
660function verify_salt_master() {
661 set -e
662
663 log_info "Verify Salt master"
664 test -n "$MASTER_HOSTNAME" || exit 1
665
666 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
Petr Michaleca5141342017-08-16 12:55:20 +0200667 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_yaml > /tmp/${MASTER_HOSTNAME}.reclass.validate_yaml
668 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_pillar > /tmp/${MASTER_HOSTNAME}.reclass.validate_pillar
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200669 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} grains.item roles > /tmp/${MASTER_HOSTNAME}.grains.item.roles
670 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} state.show_lowstate > /tmp/${MASTER_HOSTNAME}.state.show_state
671 $SUDO salt-call --no-color grains.items
672 $SUDO salt-call --no-color pillar.data
673 fi
Petr Michaleca5141342017-08-16 12:55:20 +0200674 # TODO: REMOVE reclass --nodeinfo section / run only on debug - as the only required is reclass.validate_*
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200675 if ! $SUDO reclass --nodeinfo ${MASTER_HOSTNAME} > /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo; then
676 log_err "For more details see full log /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo"
677 exit 1
678 fi
679}
680
681function verify_salt_minion() {
682 set -e
683 node=$1
684 log_info "Verifying ${node}"
685 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
686 $SUDO salt-call ${SALT_OPTS} --id=${node} grains.item roles > /tmp/${node}.grains.item.roles
687 $SUDO salt-call ${SALT_OPTS} --id=${node} state.show_lowstate > /tmp/${node}.state.show_lowstate
688 fi
689 if ! $SUDO reclass --nodeinfo ${node} > /tmp/${node}.reclass.nodeinfo; then
690 log_err "For more details see full log /tmp/${node}.reclass.nodeinfo"
691 if [[ ${BREAK_ON_VERIFICATION_ERROR:-yes} =~ ^(True|true|1|yes)$ ]]; then
692 exit 1
693 fi
694 fi
695}
696
697function verify_salt_minions() {
698 #set -e
699 NODES=$(find $RECLASS_ROOT/nodes/ -name "*.yml" | grep -v "cfg")
700 log_info "Verifying minions: $(echo ${NODES}|xargs)"
701
702 # Parallel
703 #echo $NODES | parallel --no-notice -j 2 --halt 2 "verify_salt_minion \$(basename {} .yml) > {}.pillar_verify"
704 #ls -lrta *.pillar_verify | tail -n 1 | xargs -n1 tail -n30
705
706 function filterFails() {
707 grep -v '/grains' | tee -a $1 | tail -n20
708 }
709
710 log_info "Verify nodes"
711 passed=0
712 for node in ${NODES}; do
713 node=$(basename $node .yml)
714
715 # filter first in cluster.. ctl-01, mon-01, etc..
716 if [[ "${node//.*}" =~ 01 || "${node//.*}" =~ 02 ]] ;then
717 verify_salt_minion ${node} || continue
718 else
719 echo Skipped $node.
720 fi
721 passed=$(($passed+1))
722 done
723 # fail on failures
724 total=$(echo $NODES | xargs --no-run-if-empty -n1 echo |wc -l)
725 test ! $passed -lt $total || log_err "Results: $passed of $total passed."
726 test ! $passed -lt $total || {
727 tail -n50 /tmp/*.pillar_verify
728 return 1
729 }
730}
731
732
733
734##########################################
735# To install salt master/minon
736
737function install() {
738 setup $@
739}
740
741function setup() {
742 # CLI
743 while [ x"$1" != x"" ]; do
744 which curl &>/dev/null || $PKGTOOL -y install curl &>/dev/null
745
746 case $1 in
747 master )
748 install_salt_master_$SALT_SOURCE
749 install_salt_minion_$SALT_SOURCE
750 install_salt_formula_$FORMULAS_SOURCE
751 ;;
752 minion )
753 install_salt_minion_$SALT_SOURCE
754 ;;
755 esac
756 shift
757 done
758 echo DONE
759}
760
761function bootstrap() {
762 log_info "Bootstrap & verification of SaltMaster and configured minions."
763 trap _atexit INT TERM EXIT
764
765 system_config_master
766 saltmaster_bootstrap &&\
Petr Michalec58575b92017-08-20 10:42:25 +0200767 saltmaster_init #&&\
Petr Michaleca5141342017-08-16 12:55:20 +0200768 #verify_salt_minions
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200769}
770
771function default() {
772 bootstrap $@
773}
774
775
776##########################################
777[[ "$0" != "$BASH_SOURCE" ]] || {
778# unless file is being sourced
779 default $@
780}